package com.ziplinegreen.vault.Service;


import com.ziplinegreen.vault.Model.Post;
import com.ziplinegreen.vault.Repository.PostRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

@Service
public class PostService {

    @Autowired
    private PostRepository postRepository;

    @Autowired
    public PostService(PostRepository postRepository) {
        this.postRepository = postRepository;
    }

    public Post createPost(Post post){
        return postRepository.save(post);
    }

    public Iterable<Post> getAllPosts(){
        return postRepository.findAll();
    }

    public ResponseEntity deletePost(Long postId){
        postRepository.delete(postRepository.findById(postId).get());
        return new ResponseEntity<>(HttpStatus.OK);
    }

    public ResponseEntity deleteAllPosts(Long userId){
        Iterable<Post> posts = findByUserId(userId);
        for(Post post: posts){
            deletePost(post.getId());
        }
        return new ResponseEntity<>(HttpStatus.OK);
    }

    public Iterable<Post> findByUserId(Long userId) {
        return postRepository.findByUserId(userId);
    }

    public Post updatePost(Long postId, String message){
        Post post = postRepository.findById(postId).get();
        post.setMessage(message);
        return postRepository.save(post);
    }

}

